SystemOrganization addCategory: #'PACO-Prototyping-Decorators'!
SystemOrganization addCategory: #'PACO-Prototyping-Decorators-Test'!
SystemOrganization addCategory: #'PACO-Prototyping-Metaprogramming'!
SystemOrganization addCategory: #'PACO-Prototyping-Metaprogramming-Test'!
SystemOrganization addCategory: #'PACO-Prototyping-Metaprogramming-Dynamic'!

Trait named: #TCuenta
	uses: {}
	category: 'PACO-Prototyping-Decorators-Test'!

!TCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 18:55'!
depositar: unMonto
	self saldo: self saldo + unMonto! !

!TCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 18:55'!
extraer: unMonto
	self saldo: self saldo - unMonto! !

!TCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 18:55'!
puedoExtraer: unMonto
	self saldo > unMonto! !

Trait named: #TLimiteExtraccionDiario
	uses: {}
	category: 'PACO-Prototyping-Decorators-Test'!

!TLimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:33'!
doExtraer: unMonto
	self delegate extraer: unMonto! !

!TLimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:32'!
extraer: unMonto
	(self puedoExtraer: unMonto)
		ifTrue: [
			self extraido: self extraido + unMonto.
			self doExtraer: unMonto]
		ifFalse: [NoSePuedeExtraer signal]! !

!TLimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:26'!
initialize
	super initialize.
	self extraido: 0.! !

!TLimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:55'!
puedoExtraer: unMonto
	^ self limiteDiario - self extraido >= unMonto! !

Trait named: #TLimiteExtraccionDiarioMeta
	uses: TLimiteExtraccionDiario
	category: 'PACO-Prototyping-Metaprogramming-Test'!

TLimiteExtraccionDiarioMeta classTrait
	uses: TLimiteExtraccionDiario classTrait!

!TLimiteExtraccionDiarioMeta classSide methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 20:17'!
expectedProperties
	^ #(limiteDiario extraido)! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:28'!
delegate
	^ super! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:33'!
doExtraer: unMonto
	super extraer: unMonto! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:39'!
extraido
	 ^ self requirement.! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:39'!
extraido: unMonto
	 ^ self requirement.! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:39'!
limiteDiario
	 ^ self requirement.! !

!TLimiteExtraccionDiarioMeta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:39'!
limiteDiario: unLimite
	 ^ self requirement! !

Trait named: #TMetaProto
	uses: {}
	category: 'PACO-Prototyping-Metaprogramming'!

!TMetaProto classSide methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 19:53'!
classNameWith: aTrait
	^ (self name, 'With', aTrait name) asSymbol ! !

!TMetaProto classSide methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 19:55'!
classWith: aTrait
	| newClass newClassName |
	newClass := self subclass: (self classNameWith: aTrait)
		uses: aTrait
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'PAOO-Prototyping-Metaprogramming-Dynamic'.
	
	newClass expectedProperties do: [ :propertyName | 
		PropertyBuilder add: propertyName toClass: newClass  ].
	
	^ newClass ! !

!TMetaProto classSide methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 21:41'!
requiredProperties: aTrait
	^ aTrait allMethods select: [:method | method sendsSelector: #requirement]! !

!TMetaProto classSide methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 19:33'!
with: aTrait
	^ (self classWith: aTrait) new
! !

Trait named: #TPrototypable
	uses: {}
	category: 'PACO-Prototyping-Decorators'!

!TPrototypable methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 17:41'!
with: aDecorator
	^ aDecorator decorate: self ! !

TestCase subclass: #MetaprogrammedPrototypesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Metaprogramming-Test'!

!MetaprogrammedPrototypesTest methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 21:18'!
testAddPrototype
	| cuenta | 
	cuenta := MCuenta with: TLimiteExtraccionDiarioMeta.
	[
		cuenta depositar: 2000.
		cuenta limiteDiario: 1000.

		self assert: (cuenta puedoExtraer: 1).

		cuenta extraer: 1000.
		self deny: (cuenta puedoExtraer: 1).
	
		self should: [ cuenta extraer: 1 ] raise: NoSePuedeExtraer
	] 
	ensure: [ "cuenta class removeFromSystem" ]! !

TestCase subclass: #PrototypableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Decorators-Test'!

!PrototypableTest methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 21:05'!
testAddPrototype
	| cuenta | 
	cuenta := Cuenta new with: (LimiteExtraccionDiario de: 1000).
	cuenta depositar: 2000.

	self assert: (cuenta puedoExtraer: 1).

	cuenta extraer: 1000.
	self deny: (cuenta puedoExtraer: 1).
	
	self should: [ cuenta extraer: 1 ] raise: NoSePuedeExtraer! !

Error subclass: #NoSePuedeExtraer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Decorators-Test'!

Object subclass: #Cuenta
	uses: TPrototypable + TCuenta
	instanceVariableNames: 'saldo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Decorators-Test'!

Cuenta class
	uses: TPrototypable classTrait + TCuenta classTrait
	instanceVariableNames: 'saldo'!

Cuenta class
	uses: TPrototypable classTrait + TCuenta classTrait
	instanceVariableNames: 'saldo'!

!Cuenta methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 20:23'!
initialize
	self saldo: 0.! !

!Cuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 18:00'!
saldo
	^ saldo! !

!Cuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 18:00'!
saldo: anObject
	saldo := anObject! !

Object subclass: #GenericDecorator
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Decorators'!

!GenericDecorator class methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 17:42'!
decorate: aDelegate
	^ self new delegate: aDelegate! !

!GenericDecorator methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 17:42'!
decorate: aDelegate
	^ self copy delegate: aDelegate! !

!GenericDecorator methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 17:42'!
delegate
	^ delegate! !

!GenericDecorator methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 17:42'!
delegate: anObject
	delegate := anObject! !

!GenericDecorator methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 17:37'!
doesNotUnderstand: aMessage
	^ delegate perform: aMessage selector withArguments: aMessage arguments.! !

GenericDecorator subclass: #LimiteExtraccionDiario
	uses: TLimiteExtraccionDiario
	instanceVariableNames: 'limite extraido limiteDiario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Decorators-Test'!

LimiteExtraccionDiario class
	uses: TLimiteExtraccionDiario classTrait
	instanceVariableNames: ''!

!LimiteExtraccionDiario class methodsFor: 'instance creation' stamp: 'npasserini 9/26/2011 20:25'!
de: unMonto
	^ self new limiteDiario: unMonto.! !

!LimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 17:39'!
extraido
	^ extraido! !

!LimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 17:39'!
extraido: anObject
	extraido := anObject! !

!LimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:18'!
limiteDiario
	^ limiteDiario! !

!LimiteExtraccionDiario methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:18'!
limiteDiario: anObject
	limiteDiario := anObject! !

Object subclass: #MCuenta
	uses: TCuenta + TMetaProto
	instanceVariableNames: 'saldo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Metaprogramming-Test'!

MCuenta class
	uses: TCuenta classTrait + TMetaProto classTrait
	instanceVariableNames: ''!

!MCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:02'!
initialize
	self saldo: 0! !

!MCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:01'!
saldo
	^ saldo! !

!MCuenta methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:01'!
saldo: anObject
	saldo := anObject! !

MCuenta subclass: #MCuentaWithTLimiteExtraccionDiarioMeta
	uses: TLimiteExtraccionDiarioMeta
	instanceVariableNames: 'limiteDiario extraido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Metaprogramming-Dynamic'!

MCuentaWithTLimiteExtraccionDiarioMeta class
	uses: TLimiteExtraccionDiarioMeta classTrait
	instanceVariableNames: ''!

!MCuentaWithTLimiteExtraccionDiarioMeta methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 21:33'!
extraido 
	^extraido! !

!MCuentaWithTLimiteExtraccionDiarioMeta methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 21:33'!
extraido: newValue 
	extraido := newValue! !

Object subclass: #PropertyBuilder
	instanceVariableNames: 'classToEdit propertyName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PACO-Prototyping-Metaprogramming'!

!PropertyBuilder class methodsFor: 'as yet unclassified' stamp: 'npasserini 9/26/2011 19:35'!
add: propertyName toClass: classToEdit
	self new
		propertyName: propertyName;
		classToEdit: classToEdit;
		execute.
! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:33'!
accessorCode
	^ self accessorName, ' 
	^', self propertyName.
	"^ MethodCodeBuilder new
		name: self accessorName;
		return: self propertyName
		asString."! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:57'!
accessorName
	^ self propertyName! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:33'!
classToEdit
	^ classToEdit! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:33'!
classToEdit: anObject
	classToEdit := anObject! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:34'!
ensureAccessor.
	(self classToEdit includesSelector: self accessorName) ifFalse: [
		self ensureInstanceVariable.
		self classToEdit compile: self accessorCode.
	]
! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 20:31'!
ensureInstanceVariable.
	(self classToEdit hasInstVarNamed: self propertyName) ifFalse: [
		self classToEdit addInstVarNamed: (self propertyName asString).
	]
! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:34'!
ensureMutator
	(self classToEdit includesSelector: self mutatorName) ifFalse: [
		self ensureInstanceVariable.
		self classToEdit compile: self mutatorCode.
	]
! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:26'!
execute
	self ensureAccessor.
	self ensureMutator
! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 21:33'!
mutatorCode
	^ self mutatorName, ' newValue 
	', self propertyName, ' := newValue'.! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:59'!
mutatorName
	^ (self propertyName, ':') asSymbol ! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:33'!
propertyName
	^ propertyName! !

!PropertyBuilder methodsFor: 'accessing' stamp: 'npasserini 9/26/2011 19:33'!
propertyName: anObject
	propertyName := anObject! !
